<?php
namespace Claromentis\Core\Event;

$GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"] ?: array()) + array("_9a9e2d14785bdbae" . "cfc454cb009e47a7" => base64_decode("MTA" . "="), "_f6ad69e5b7ae" . "7662b1d0fa058" . "47ada65" => base64_decode("Y2xhcm9tZW50aX" . "MvZnJhbWV3b3Jr"), "_d91a7be21d972d4" . "aac861a7352a2079" . "f" => base64_decode("c2V0T" . "mFtZQ" . "=="), "_7cf32751" . "5b98333f2" . "887781d25" . "82ce87" => base64_decode("TWV0aG9kIHNpZ25hdHVyZSBkZXByZWNhdGVkIGZvciB0aGUgRXZlbnREaXNwYXRjaGVyOjpkaXNwYXRjaCgpIHNpbmNlIENvcmUgMTAsIGR1ZSB0byBTeW1mb255IDUncyBjaGFuZ2VzOiBzd2FwIHRoZSBmaXJzdCB0d28gYXJndW1" . "lbnRzIHRvIHRoaXMgbWV0aG9k"), "_96be32a6f44bf54e635e1736acf7a9" . "6c" => base64_decode("c2VyaWFsa" . "Xpl"), "_6edacb78bd55c5015af27c8ac1fcd" . "9af" => base64_decode("bWV0aG9kX2V4aX" . "N0cw=="), "_c244a470df52" . "d1d5a7085138e" . "c94e393" => base64_decode("dW5zZXJ" . "pYWxpem" . "U="), "_db6f0ba0791e9a6354076" . "59a9fe04e40" => base64_decode("aXN" . "fb2" . "JqZ" . "WN0"), "_249e641075c6a29865e4c4b46" . "d959e7f" => base64_decode("dHJpZ2d" . "lcl9kZX" . "ByZWNhd" . "Glvbg=="));
use Claromentis\Common\ApplicationMiscellany\Finisher;
use Claromentis\Core\Services;
use Symfony\Contracts\EventDispatcher\Event;
use Symfony\Component\EventDispatcher\EventDispatcher as BaseEventDispatcher;




class EventDispatcher extends BaseEventDispatcher implements EventDispatcherInterface
{
    
    
    
    
    
    
    protected ?Finisher $finisher;
    
    
    
    
    public function __construct(Finisher $_fea16585ee8de2b835a68ccd4bc60aef = null)
    {
        parent::__construct();
        $this->finisher = $_fea16585ee8de2b835a68ccd4bc60aef;
    }
    
    
    
    
    
    
    
    
    public static function Shared()
    {
        return Services::I()->dispatcher;
    }
    
    
    
    
    
    
    
    
    
    
    
    public function dispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b = null, bool $_46d17db0bd1ac920366ce3e210c240c1 = false) : object
    {
        if ($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_db6f0ba0791e9a635407" . "659a9fe04e40"]($event)) {
            return $this->bcAwareDispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b, $_46d17db0bd1ac920366ce3e210c240c1);
        }
        $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_249e641075c6a29865e4c" . "4b46d959e7f"]($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_f6ad69e5b7a" . "e7662b1d0fa0" . "5847ada65"], $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_9a9e2d14785bdbaecfc454" . "cb009e47a7"], $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_7cf327515b98333f288" . "7781d2582ce87"]);
        return $this->bcAwareDispatch($_2cf093f28f4c7e718a5e8af628894c7b, $event, $_46d17db0bd1ac920366ce3e210c240c1);
    }
    
    
    
    
    
    
    
    
    
    private function bcAwareDispatch(object $event = null, ?string $_2cf093f28f4c7e718a5e8af628894c7b, bool $_46d17db0bd1ac920366ce3e210c240c1 = false) : object
    {
        if ($event === null) {
            $event = new Event();
        }
        if ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_6edacb78bd55c5015af27c8" . "ac1fcd9af"]($event, $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_d91a7be21" . "d972d4aac8" . "61a7352a20" . "79f"])) {
            $event->setName($_2cf093f28f4c7e718a5e8af628894c7b);
        }
        if (!$_46d17db0bd1ac920366ce3e210c240c1 || !isset($this->finisher)) {
            return parent::dispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b);
        } else {
            $_a6a149597bf68ad5294d98abc0bda72b = $GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_96be32a6f44bf54e635" . "e1736acf7a96c"]($event);
            $this->finisher->FinishHim(function ($request, $_fd5a3a643834299cbdadfc3540ba0bcb) use($_2cf093f28f4c7e718a5e8af628894c7b, $_a6a149597bf68ad5294d98abc0bda72b) {
                $event = $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_c244a470df52d1" . "d5a7085138ec94e" . "393"]($_a6a149597bf68ad5294d98abc0bda72b);
                $this->dispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b, false);
            });
            return $event;
        }
    }
}